using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using Datory;
using GxPress.Common.Page;
using GxPress.Request.App.Note;
using GxPress.Result.App.Note;

namespace GxPress.Repository.Interface.Note
{
    public interface INoteRepository : IRepository
    {

        /// <summary>
        /// 获取笔记
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        Task<Entity.Note.Note> GetAsync(int id);
        /// <summary>
        /// 添加笔记
        /// </summary>
        /// <param name="note"></param>
        /// <returns></returns>
        Task<int> InsertAsync(Entity.Note.Note note);
        /// <summary>
        /// 修改笔记
        /// </summary>
        /// <param name="note"></param>
        /// <returns></returns>
        Task<bool> UpdateAsync(Entity.Note.Note note);

        /// <summary>
        /// 获取笔记分页
        /// </summary>
        /// <param name="request"></param>
        /// <returns></returns>
        Task<PagedList<NotePageListRequest>> NotePageListAsync(NoteSearchPageListRequest request);

        Task<bool> DeleteAsync(SqlKata.Query query);

        Task<bool> DeleteAsync(int id);

        Task<bool> UpdateAsync(SqlKata.Query query);
    }
}
